/***************************************************************************
 *   Copyright (C) 2008  Antony Martin <martin(dot)antony(at)yahoo(dot)fr> *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 27/02/2008
   derniere modification : 19/03/2008 */

#ifndef SCEBOUNDINGBOX_H
#define SCEBOUNDINGBOX_H

#include <SCE/utils/SCEMatrix.h>
#include <SCE/utils/SCEVector.h>

typedef struct sce_sboundingbox SCE_SBoundingBox;
struct sce_sboundingbox
{
    SCE_TVector3 p[8];
    SCE_TVector3 olds[8];
    int pushed;
};


/* initialise une structure de bounding box */
void SCE_BoundingBox_Init (SCE_SBoundingBox*);

/* defini une bounding box */
void SCE_BoundingBox_Set (SCE_SBoundingBox*, SCE_TVector3, float, float, float);
void SCE_BoundingBox_Setv (SCE_SBoundingBox*, SCE_TVector3, SCE_TVector3);

/* retourne le centre de la bounding box */
void SCE_BoundingBox_GetCenterv (SCE_SBoundingBox*, SCE_TVector3);

/* retourne les 8 points d'une bounding box */
float* SCE_BoundingBox_GetPoints (SCE_SBoundingBox*);
void SCE_BoundingBox_GetPointsv (SCE_SBoundingBox*, SCE_TVector3*);

/* assigne une matrice aux points d'une bounding box */
void SCE_BoundingBox_Push (SCE_SBoundingBox*, SCE_TMatrix4);
/* restaure les points sauvegardes avant l'application d'une matrice */
void SCE_BoundingBox_Pop (SCE_SBoundingBox*);

#endif /* guard */
